#include <bits/stdc++.h>
#include <code.h>
using namespace std;
vector<pair<int, int>> ZapisiTacke(int n)
{
    vector <pair<int, int>> tacke(n+1);
    tacke[1]={0, 0};
    for (int i=2; i<=n; i++)
    {
        tacke[i]={n-i+1, i-1};
    }
    return tacke;
}
vector<int> Resi(int n, int q)
{
    int piv=-1;
    if (n>4)
    {
        for (int i=1; i<=n; i++)
        {
            vector <int> razl;
            for (int j=1; j<=n; j++)
            {
                if (razl.size()==4) break;
                if (j!=i) razl.push_back(j);
            }
            if (Pitaj(i, razl[0], razl[1])!=0 && Pitaj(i, razl[2], razl[3])!=0)
            {
                piv=i;
                break;
            }
        }
    }
    else
    {
        for (int i=1; i<=4; i++)
        {
            for (int j=i+1; j<=4; j++)
            {
                for (int k=j+1; k<=4; k++)
                {
                    if (Pitaj(i, j, k)==0)
                    {
                        for (int l=1; l<=4; l++)
                        {
                            if (l!=i && l!=j && l!=k)
                            {
                                 piv=l;
                                 break;
                            }
                        }
                        break;
                    }
                }
            }
        }
    }
    vector <pair<int, int>> visi(n+1);
    for (int i=1; i<=n; i++) {visi[i].first=0; visi[i].second=i;}
    for (int i=1; i<=n; i++)
    {
        if (i==piv) continue;
        for (int j=i+1; j<=n; j++)
        {
            if (j==piv) continue;
            if (Pitaj(piv, i, j)==1)
            {
                visi[i].first++;
            }
            else
            {
                visi[j].first++;
            }
        }
    }
    sort(visi.begin(), visi.end());
    vector <int> ans(n+1);
    if (visi[2].second==piv) swap(visi[1], visi[2]);
    int cnt=2;
    ans[piv]=1;
    for (int i=n; i>=2; i--)
    {
       ans[visi[cnt].second]=i;
       cnt++;
    }
    return ans;
}